<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: spectral_cluster.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_0c582804897264a9800649f65c0dcc91.html">clustering</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">spectral_cluster.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2015  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_SPECTRAL_CLUSTEr_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_SPECTRAL_CLUSTEr_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;spectral_cluster_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../svm/kkmeans.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="keyword">typename</span> kernel_type,</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keyword">typename</span> vector_type</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        &gt;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    std::vector&lt;unsigned long&gt; spectral_cluster (</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">const</span> kernel_type&amp; k,</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">const</span> vector_type&amp; samples,</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_clusters</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    )</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    {</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        DLIB_CASSERT(num_clusters &gt; 0, </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;            <span class="stringliteral">&quot;\t std::vector&lt;unsigned long&gt; spectral_cluster(k,samples,num_clusters)&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;\n\t num_clusters can&#39;t be 0.&quot;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;            );</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keywordflow">if</span> (num_clusters == 1)</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;            <span class="comment">// nothing to do, just assign everything to the 0 cluster.</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;            <span class="keywordflow">return</span> std::vector&lt;unsigned long&gt;(samples.size(), 0);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        }</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="comment">// compute the similarity matrix.</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        matrix&lt;double&gt; K(samples.size(), samples.size());</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; K.nr(); ++r)</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">long</span> c = r+1; c &lt; K.nc(); ++c)</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;                K(r,c) = K(c,r) = (double)k(samples[r], samples[c]);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; K.nr(); ++r)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;            K(r,r) = 0;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        matrix&lt;double,0,1&gt; D(K.nr());</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; K.nr(); ++r)</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;            D(r) = sum(rowm(K,r));</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        D = sqrt(reciprocal(D));</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        K = diagm(D)*K*diagm(D); </div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        matrix&lt;double&gt; u,w,v;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="comment">// Use the normal SVD routine unless the matrix is really big, then use the fast</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="comment">// approximate version.</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordflow">if</span> (K.nr() &lt; 1000)</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            svd3(K,u,w,v);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            svd_fast(K,u,w,v, num_clusters+100, 5);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="comment">// Pick out the eigenvectors associated with the largest eigenvalues.</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        rsort_columns(v,w);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        v = colm(v, range(0,num_clusters-1));</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="comment">// Now build the normalized spectral vectors, one for each input vector.</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        std::vector&lt;matrix&lt;double,0,1&gt; &gt; spec_samps, centers;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; v.nr(); ++r)</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            spec_samps.push_back(trans(rowm(v,r)));</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> len = length(spec_samps.back());</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <span class="keywordflow">if</span> (len != 0)</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;                spec_samps.back() /= len;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="comment">// Finally do the K-means clustering</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        pick_initial_centers(num_clusters, centers, spec_samps);</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        find_clusters_using_kmeans(spec_samps, centers);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="comment">// And then compute the cluster assignments based on the output of K-means.</span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        std::vector&lt;unsigned long&gt; assignments;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; spec_samps.size(); ++i)</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            assignments.push_back(nearest_center(centers, spec_samps[i]));</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keywordflow">return</span> assignments;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    }</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;}</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="preprocessor">#endif // DLIB_SPECTRAL_CLUSTEr_H_</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
